/*

  Le Pin - A multiplayer game for saturn
  
  Copyright (C) 2002 SSMTF
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*********************************************************
 * SCROLL TEXT
 ********************************************************/

// FIXME : display errors 

#include "sgl.h"
#include "scrltxt.h"

/*
 * PRIVATE defs
 */

#define TXT_MAX_LINE      15
#define TXT_MAX_COL       25
#define TXT_SCROLL_PERIOD 15 // en nb de balayage
//                         01234567890123456789012345
#define TXT_EMPTY         "                          "
typedef enum e_contents{
  empty,t_fixed, t_txt
} e_contents;


typedef struct txt_line {
  char txt[TXT_MAX_COL+1];
} TXT_LINE;

typedef struct data_line {
  e_contents contents;
  TXT_LINE txt_data;    // used if content[i] == t_txt 
  FIXED fixed_data;      // used if content[i] == t_fixed 
} DATA_LINE;

typedef struct ScrollTxt {
  int curLine;            // emulation buffer circulaire : el prochain ajout
  DATA_LINE line[TXT_MAX_LINE+1];
  int r_time;
} SCROLL_TXT; 

SCROLL_TXT ScrollTxt;            // texte defilant

/*
 * FUNCTIONS
 */

void scrollTxtAddLine(e_contents contents, char* in_txt,FIXED in_fixed){
  int i;

  ScrollTxt.curLine++;
  if (ScrollTxt.curLine>TXT_MAX_LINE) ScrollTxt.curLine=0;

  ScrollTxt.line[ScrollTxt.curLine].contents = contents;
  switch(contents){
  case empty:
    break;
  case t_txt :
    for (i=0;i<TXT_MAX_COL;i++) {
      ScrollTxt.line[ScrollTxt.curLine].txt_data.txt[i]=in_txt[i];
    }; break;
  case t_fixed :
    ScrollTxt.line[ScrollTxt.curLine].fixed_data = in_fixed;
    break;
  }
  ScrollTxt.r_time = TXT_SCROLL_PERIOD;  
}

void scrollTxtAddTxtLine(char* inp){
  e_contents contents;
  contents = t_txt; 
  scrollTxtAddLine(contents, inp, toFIXED(0.0));
}

void scrollTxtAddFIXEDLine(FIXED inp){
  e_contents contents  = t_fixed; 
  scrollTxtAddLine(contents,"", inp);
}

void scrollTxtDisplay(){
  int i,j;

  if (ScrollTxt.curLine == -1) return; // caca
  j = ScrollTxt.curLine;

  for (i = 0;i<=TXT_MAX_LINE;i++){
    
    j++;
    if (j>TXT_MAX_LINE) j=0;

    switch (ScrollTxt.line[j].contents) {
    case empty : 
      slPrint(TXT_EMPTY,slLocate(1,i+1));
      break;
    case t_txt : 
      slPrint(ScrollTxt.line[j].txt_data.txt,slLocate(1,i+1));	
      break;
    case t_fixed : 
      slPrintFX(ScrollTxt.line[j].fixed_data,slLocate(1,i+1));
      break;     
    }
  }    
}


void EmptyLine(i) {
  ScrollTxt.line[i].contents = empty;
}

void scrollTxtInit() {
  int i;
  for (i = 0; i <= TXT_MAX_LINE ; i++) {
    EmptyLine(i);
  }
  ScrollTxt.curLine = -1;
  ScrollTxt.r_time = TXT_SCROLL_PERIOD;
}
void addEmptyLine() {
  scrollTxtAddLine(empty, "", toFIXED(0.0));  
  EmptyLine(ScrollTxt.curLine);
}

void scrollTxtSchedule(){
  if (--ScrollTxt.r_time == 0) {
    addEmptyLine();
    ScrollTxt.r_time = TXT_SCROLL_PERIOD;
  }
}
